Index: tmp/org.txm.setups/nsis/Include/UpgradeDLL.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/UpgradeDLL.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/UpgradeDLL.nsh	(revision 2956)
@@ -60,26 +60,30 @@
   ;Advance counter
 
   StrCpy $R0 0
-  ReadRegDWORD $R0 HKLM "Software\NSIS.Library.RegTool.v2\UpgradeDLLSession" "count"
+  ReadRegDWORD $R0 HKLM "Software\NSIS.Library.RegTool.v3\UpgradeDLLSession" "count"
   IntOp $R0 $R0 + 1
-  WriteRegDWORD HKLM "Software\NSIS.Library.RegTool.v2\UpgradeDLLSession" "count" "$R0"
+  WriteRegDWORD HKLM "Software\NSIS.Library.RegTool.v3\UpgradeDLLSession" "count" "$R0"
 
   ;------------------------
   ;Setup RegTool
 
-  ReadRegStr $R3 HKLM "Software\Microsoft\Windows\CurrentVersion\RunOnce" "NSIS.Library.RegTool.v2"
+  !if ! /FileExists "${NSISDIR}\Bin\RegTool-${NSIS_CPU}.bin"
+    !error "Missing RegTool for ${NSIS_CPU}!"
+  !endif
+
+  ReadRegStr $R3 HKLM "Software\Microsoft\Windows\CurrentVersion\RunOnce" "NSIS.Library.RegTool.v3"
   StrCpy $R3 $R3 -4 1
   IfFileExists $R3 +3
 
-    File /oname=$R2\NSIS.Library.RegTool.v2.$HWNDPARENT.exe "${NSISDIR}\Bin\RegTool.bin"
+    File /oname=$R2\NSIS.Library.RegTool.v3.$HWNDPARENT.exe "${NSISDIR}\Bin\RegTool-${NSIS_CPU}.bin"
     WriteRegStr HKLM "Software\Microsoft\Windows\CurrentVersion\RunOnce" \
-      "NSIS.Library.RegTool.v2" '"$R2\NSIS.Library.RegTool.v2.$HWNDPARENT.exe" /S'
+      "NSIS.Library.RegTool.v3" '"$R2\NSIS.Library.RegTool.v3.$HWNDPARENT.exe" /S'
 
   ;------------------------
   ;Add RegTool entry
 
-  WriteRegStr HKLM "Software\NSIS.Library.RegTool.v2\UpgradeDLLSession" "$R0.file" "$R1"
-  WriteRegStr HKLM "Software\NSIS.Library.RegTool.v2\UpgradeDLLSession" "$R0.mode" "${mode}"
+  WriteRegStr HKLM "Software\NSIS.Library.RegTool.v3\UpgradeDLLSession" "$R0.file" "$R1"
+  WriteRegStr HKLM "Software\NSIS.Library.RegTool.v3\UpgradeDLLSession" "$R0.mode" "${mode}"
 
   Pop $R3
   Pop $R2
@@ -102,8 +106,8 @@
   SetOverwrite try
 
   ;------------------------
-  ;Copy the parameters used on run-time to a variable
-  ;This allows the usage of variables as paramter
+  ;Copy the macro parameters to a run-time to a variable, 
+  ;this allows the usage of variables as parameter
 
   StrCpy $R4 "${DESTFILE}"
   StrCpy $R5 "${TEMPBASEDIR}"
Index: tmp/org.txm.setups/nsis/Include/LogicLib.nsh
===================================================================
--- tmp/org.txm.setups/nsis/Include/LogicLib.nsh	(revision 2955)
+++ tmp/org.txm.setups/nsis/Include/LogicLib.nsh	(revision 2956)
@@ -47,7 +47,7 @@
 ;       Case-sensitive string tests:
 ;         a S== b; a S!= b
 ;       Standard (built-in) signed integer tests:
-;         a = b; a <> b; a < b; a >= b; a > b; a <= b
+;         a = b; a <> b; a < b; a >= b; a > b; a <= b; a & b
 ;       Standard (built-in) unsigned integer tests:
 ;         a U< b; a U>= b; a U> b; a U<= b
 ;       64-bit integer tests (using System.dll):
@@ -57,7 +57,8 @@
 ;       size_t integer tests
 ;         a Z= b; a Z<> b; a Z< b; a Z>= b; a Z> b; a Z<= b
 ;       Built-in NSIS flag tests:
-;         ${Abort}; ${Errors}; ${RebootFlag}; ${Silent}
+;         ${Abort}; ${Errors}; ${RebootFlag}; ${Silent}; ${RtlLanguage};
+;         ${ShellVarContextAll}
 ;       Built-in NSIS other tests:
 ;         ${FileExists} a
 ;       Any conditional NSIS instruction test:
@@ -67,6 +68,8 @@
 ;         ${SectionIsSectionGroupEnd} a; ${SectionIsBold} a;
 ;         ${SectionIsReadOnly} a; ${SectionIsExpanded} a;
 ;         ${SectionIsPartiallySelected} a
+;       Additional tests:
+;         HK RegKeyIsEmpty SubKey
 ;
 ; Examples:
 ;   See LogicLib.nsi in the Examples folder for lots of example usage.
@@ -95,11 +98,14 @@
     !endif
   !macroend
 
+  !macro LogicLib_JumpToBranch _Jump _Skip
+    !if `${_Jump}` != ``
+      StrCmp "" "" `${_Jump}` ${_Skip}
+    !endif
+  !macroend
+
   !macro _IncreaseCounter
-    !define _LOGICLIB_COUNTER ${LOGICLIB_COUNTER}
-    !undef LOGICLIB_COUNTER
-    !define /math LOGICLIB_COUNTER ${_LOGICLIB_COUNTER} + 1
-    !undef _LOGICLIB_COUNTER
+    !define /redef /math LOGICLIB_COUNTER `${LOGICLIB_COUNTER}` + 1
   !macroend
 
   !macro _PushLogic
@@ -159,7 +165,7 @@
   ; Extra string tests (cannot do these case-sensitively - I tried and lstrcmp still ignored the case)
   !macro _StrCmpI _a _b _e _l _m
     !insertmacro _LOGICLIB_TEMP
-    System::Call `kernel32::lstrcmpiA(ts, ts) i.s` `${_a}` `${_b}`
+    System::Call `kernel32::lstrcmpi(ts, ts) i.s` `${_a}` `${_b}`
     Pop $_LOGICLIB_TEMP
     IntCmp $_LOGICLIB_TEMP 0 `${_e}` `${_l}` `${_m}`
   !macroend
@@ -205,6 +211,12 @@
     !insertmacro _> `${_a}` `${_b}` `${_f}` `${_t}`
   !macroend
 
+  !macro _& _a _b _t _f
+    !insertmacro _LOGICLIB_TEMP
+    IntOp $_LOGICLIB_TEMP `${_a}` & `${_b}`
+    !insertmacro _<> $_LOGICLIB_TEMP 0 `${_t}` `${_f}`
+  !macroend
+
   ; Unsigned integer tests (NB: no need for extra equality tests)
   !macro _U< _a _b _t _f
     IntCmpU `${_a}` `${_b}` `${_f}` `${_t}` `${_f}`
@@ -255,41 +267,49 @@
   !macroend
 
   ; ptrdiff_t & size_t tests
+  !macro LogicLib_PtrDiffTest _o _a _b _t _f
+    !if "${NSIS_PTR_SIZE}" <= 4
+      !insertmacro _${_o} `${_a}` `${_b}` `${_t}` `${_f}`
+    !else
+      !insertmacro _L${_o} `${_a}` `${_b}` `${_t}` `${_f}`
+    !endif
+  !macroend
   !macro _P= _a _b _t _f
-    !insertmacro _= `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest = `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _P<> _a _b _t _f
-    !insertmacro _<> `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest <> `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _P< _a _b _t _f
-    !insertmacro _< `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest < `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _P>= _a _b _t _f
-    !insertmacro _>= `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest >= `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _P> _a _b _t _f
-    !insertmacro _> `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest > `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _P<= _a _b _t _f
-    !insertmacro _<= `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest <= `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
+  !include Util.nsh
   !macro _Z= _a _b _t _f
-    !insertmacro _= `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest = `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _Z<> _a _b _t _f
-    !insertmacro _<> `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro LogicLib_PtrDiffTest <> `${_a}` `${_b}` `${_t}` `${_f}`
   !macroend
   !macro _Z< _a _b _t _f
-    !insertmacro _U< `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro IntPtrCmpU `${_a}` `${_b}` `${_f}` `${_t}` `${_f}`
   !macroend
   !macro _Z>= _a _b _t _f
-    !insertmacro _U>= `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro IntPtrCmpU `${_a}` `${_b}` `${_t}` `${_f}` `${_t}`
   !macroend
   !macro _Z> _a _b _t _f
-    !insertmacro _U> `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro IntPtrCmpU `${_a}` `${_b}` `${_f}` `${_f}` `${_t}`
   !macroend
   !macro _Z<= _a _b _t _f
-    !insertmacro _U<= `${_a}` `${_b}` `${_t}` `${_f}`
+    !insertmacro IntPtrCmpU `${_a}` `${_b}` `${_t}` `${_t}` `${_f}`
   !macroend
 
   ; Flag tests
@@ -318,6 +338,37 @@
   !macroend
   !define Silent `"" Silent ""`
 
+  !macro _ShellVarContextAll _a _b _t _f
+    IfShellVarContextAll `${_t}` `${_f}`
+  !macroend
+  !define ShellVarContextAll `"" ShellVarContextAll ""`
+
+  !macro _RtlLanguage _a _b _t _f
+    IfRtlLanguage `${_t}` `${_f}`
+  !macroend
+  !define RtlLanguage `"" RtlLanguage ""`
+
+  !macro _AltRegView _a _b _t _f
+    IfAltRegView `${_t}` `${_f}`
+  !macroend
+  !define AltRegView `"" AltRegView ""`
+
+  !macro _RegKeyIsEmpty _a _b _t _f
+    !insertmacro _LOGICLIB_TEMP
+    ClearErrors
+    EnumRegValue $_LOGICLIB_TEMP ${_a} `${_b}` ""
+    !if `${_f}` != ``
+    IfErrors "" `${_f}` ; Skip calls to EnumRegKey and _== if possible
+    !else
+    IfErrors +3
+    StrCpy $_LOGICLIB_TEMP "1" ; The default value is also named "", make sure we don't mistake it as empty
+    Goto +2
+    !endif
+    EnumRegKey $_LOGICLIB_TEMP ${_a} `${_b}` ""
+    !insertmacro _== $_LOGICLIB_TEMP "" `${_t}` `${_f}`
+  !macroend
+  !define RegKeyIsEmpty `RegKeyIsEmpty`
+
   ; "Any instruction" test
   !macro _Cmd _a _b _t _f
     !define _t=${_t}
@@ -365,7 +416,7 @@
     !verbose ${LOGICLIB_VERBOSITY}
     !insertmacro _PushLogic
     !define ${_Logic}If
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the Else
+    !define ${_Logic}Else _LogicLib_ElseLabel_${LOGICLIB_COUNTER} ; Get a label for the Else
     !insertmacro _IncreaseCounter
     !define _c=${_c}
     !ifdef _c=true                                        ; If is true
@@ -411,12 +462,12 @@
     !ifndef ${_Logic}Else
       !error "Cannot use Or following an Else"
     !endif
-    !define _label _LogicLib_Label_${LOGICLIB_COUNTER}                           ; Skip this test as we already
+    !define _label _LogicLib_Label_${LOGICLIB_COUNTER}    ; Skip this test as we already
     !insertmacro _IncreaseCounter
     Goto ${_label}                                        ; have a successful result
     ${${_Logic}Else}:                                     ; Place the Else label
     !undef ${_Logic}Else                                  ; and remove it
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new If
+    !define ${_Logic}Else _LogicLib_ElseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new If
     !insertmacro _IncreaseCounter
     !define _c=${_c}
     !ifdef _c=true                                        ; If is true
@@ -443,7 +494,7 @@
       !error "Cannot use Else following an Else"
     !endif
     !ifndef ${_Logic}EndIf                                ; First Else for this If?
-      !define ${_Logic}EndIf _LogicLib_Label_${LOGICLIB_COUNTER}                 ; Get a label for the EndIf
+      !define ${_Logic}EndIf _LogicLib_EndIfLabel_${LOGICLIB_COUNTER} ; Get a label for the EndIf
       !insertmacro _IncreaseCounter
     !endif
     Goto ${${_Logic}EndIf}                                ; Go to the EndIf
@@ -457,7 +508,7 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     ${Else}                                               ; Perform the Else
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new If
+    !define ${_Logic}Else _LogicLib_ElseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new If
     !insertmacro _IncreaseCounter
     !define _c=${_c}
     !ifdef _c=true                                        ; If is true
@@ -556,10 +607,10 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     !insertmacro _PushLogic
-    !define ${_Logic}${_n} _LogicLib_Label_${LOGICLIB_COUNTER}                   ; Get a label for the start of the loop
+    !define ${_Logic}${_n} _LogicLib_Label_${LOGICLIB_COUNTER} ; Get a label for the start of the loop
     !insertmacro _IncreaseCounter
     ${${_Logic}${_n}}:
-    !insertmacro _PushScope Exit${_n} _LogicLib_Label_${LOGICLIB_COUNTER}        ; Get a label for the end of the loop
+    !insertmacro _PushScope Exit${_n} _LogicLib_Label_${LOGICLIB_COUNTER} ; Get a label for the end of the loop
     !insertmacro _IncreaseCounter
     !insertmacro _PushScope Break ${_Exit${_n}}           ; Break goes to the end of the loop
     !ifdef _DoLoopExpression
@@ -568,7 +619,7 @@
     !endif
     !define _c=${_c}
     !ifdef _c=                                            ; No starting condition
-      !insertmacro _PushScope Continue _LogicLib_Label_${LOGICLIB_COUNTER}       ; Get a label for Continue at the end of the loop
+      !insertmacro _PushScope Continue _LogicLib_Label_${LOGICLIB_COUNTER} ; Get a label for Continue at the end of the loop
       !insertmacro _IncreaseCounter
     !else
       !insertmacro _PushScope Continue ${${_Logic}${_n}}  ; Continue goes to the start of the loop
@@ -618,7 +669,7 @@
     !endif
     !undef _c=${_c}
     Goto ${_Continue}                                     ; Just to ensure it is referenced at least once
-	Goto ${_Exit${_n}}                                    ; Just to ensure it is referenced at least once
+    Goto ${_Exit${_n}}                                    ; Just to ensure it is referenced at least once
     ${_Exit${_n}}:                                        ; Place the loop exit point
     !undef ${_Logic}Condition
     !insertmacro _PopScope Continue
@@ -654,11 +705,12 @@
       !ifndef ${_Logic}Else
         !error "Cannot use Case following a CaseElse"
       !endif
-      Goto ${${_Logic}EndSelect}                          ; Go to the EndSelect
+      Goto ${${_Logic}EndSelect}                          ; Go to EndSelect (Ends the previous Case)
+      !define /IfNDef _LogicLib_EndSelectLabelUsed_${_Logic}
       ${${_Logic}Else}:                                   ; Place the Else label
       !undef ${_Logic}Else                                ; and remove it
     !else
-      !define ${_Logic}EndSelect _LogicLib_Label_${LOGICLIB_COUNTER}             ; Get a label for the EndSelect
+      !define ${_Logic}EndSelect _LogicLib_EndSelectLabel_${LOGICLIB_COUNTER} ; Get a label for the EndSelect
       !insertmacro _IncreaseCounter
     !endif
     !verbose pop
@@ -671,7 +723,7 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     ${CaseElse}                                           ; Perform the CaseElse
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new Case
+    !define ${_Logic}Else _LogicLib_NextSelectCaseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new Case
     !insertmacro _IncreaseCounter
     !insertmacro _== `${${_Logic}Select}` `${_a}` "" ${${_Logic}Else}
     !verbose pop
@@ -682,7 +734,7 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     ${CaseElse}                                           ; Perform the CaseElse
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new Case
+    !define ${_Logic}Else _LogicLib_NextSelectCaseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new Case
     !insertmacro _IncreaseCounter
     !insertmacro _== `${${_Logic}Select}` `${_a}` +2 ""
     !insertmacro _== `${${_Logic}Select}` `${_b}` "" ${${_Logic}Else}
@@ -694,7 +746,7 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     ${CaseElse}                                           ; Perform the CaseElse
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new Case
+    !define ${_Logic}Else _LogicLib_NextSelectCaseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new Case
     !insertmacro _IncreaseCounter
     !insertmacro _== `${${_Logic}Select}` `${_a}` +3 ""
     !insertmacro _== `${${_Logic}Select}` `${_b}` +2 ""
@@ -707,7 +759,7 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     ${CaseElse}                                           ; Perform the CaseElse
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new Case
+    !define ${_Logic}Else _LogicLib_NextSelectCaseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new Case
     !insertmacro _IncreaseCounter
     !insertmacro _== `${${_Logic}Select}` `${_a}` +4 ""
     !insertmacro _== `${${_Logic}Select}` `${_b}` +3 ""
@@ -721,7 +773,7 @@
     !verbose push
     !verbose ${LOGICLIB_VERBOSITY}
     ${CaseElse}                                           ; Perform the CaseElse
-    !define ${_Logic}Else _LogicLib_Label_${LOGICLIB_COUNTER}                    ; Get a label for the next Else and perform the new Case
+    !define ${_Logic}Else _LogicLib_NextSelectCaseLabel_${LOGICLIB_COUNTER} ; Get a label for the next Else and perform the new Case
     !insertmacro _IncreaseCounter
     !insertmacro _== `${${_Logic}Select}` `${_a}` +5 ""
     !insertmacro _== `${${_Logic}Select}` `${_b}` +4 ""
@@ -743,7 +795,10 @@
       !undef ${_Logic}Else                                ; and remove it
     !endif
     !ifdef ${_Logic}EndSelect                             ; This won't be set if there weren't any cases
-      ${${_Logic}EndSelect}:                              ; Place the EndSelect
+      !ifdef _LogicLib_EndSelectLabelUsed_${_Logic}                 ; There is no jump to ${${_Logic}EndSelect}: if there is only one Case
+        ${${_Logic}EndSelect}:                            ; Place the EndSelect
+        !undef _LogicLib_EndSelectLabelUsed_${_Logic}
+      !endif
       !undef ${_Logic}EndSelect                           ; and remove it
     !endif
     !undef ${_Logic}Select
@@ -757,11 +812,11 @@
     !verbose ${LOGICLIB_VERBOSITY}
     !insertmacro _PushLogic
     !insertmacro _PushScope Switch ${_Logic}              ; Keep a separate stack for switch data
-    !insertmacro _PushScope Break _LogicLib_Label_${LOGICLIB_COUNTER}            ; Get a lable for beyond the end of the switch
+    !insertmacro _PushScope Break _LogicLib_Label_${LOGICLIB_COUNTER} ; Get a lable for beyond the end of the switch
     !insertmacro _IncreaseCounter
     !define ${_Switch}Var `${_a}`                         ; Remember the left hand side of the comparison
     !tempfile ${_Switch}Tmp                               ; Create a temporary file
-    !define ${_Logic}Switch _LogicLib_Label_${LOGICLIB_COUNTER}                  ; Get a label for the end of the switch
+    !define ${_Logic}Switch _LogicLib_Label_${LOGICLIB_COUNTER} ; Get a label for the end of the switch
     !insertmacro _IncreaseCounter
     Goto ${${_Logic}Switch}                               ; and go there
     !verbose pop
@@ -776,7 +831,7 @@
     !else ifndef _Switch                                  ; If not then check for an active Switch
       !error "Cannot use Case without a preceding Select or Switch"
     !else
-      !define _label _LogicLib_Label_${LOGICLIB_COUNTER}                         ; Get a label for this case,
+      !define _label _LogicLib_Label_${LOGICLIB_COUNTER}  ; Get a label for this case,
       !insertmacro _IncreaseCounter
       ${_label}:                                          ; place it and add it's check to the temp file
       !appendfile "${${_Switch}Tmp}" `!insertmacro _== $\`${${_Switch}Var}$\` $\`${_a}$\` ${_label} ""$\n`
@@ -795,7 +850,7 @@
     !else ifdef ${_Switch}Else                            ; Already had a default case?
       !error "Cannot use CaseElse following a CaseElse"
     !else
-      !define ${_Switch}Else _LogicLib_Label_${LOGICLIB_COUNTER}                 ; Get a label for the default case,
+      !define ${_Switch}Else _LogicLib_Label_${LOGICLIB_COUNTER} ; Get a label for the default case,
       !insertmacro _IncreaseCounter
       ${${_Switch}Else}:                                  ; and place it
     !endif
